// PW_AccessDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PW_Access.h"
#include "PW_AccessDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPW_AccessDlg dialog

CPW_AccessDlg::CPW_AccessDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPW_AccessDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPW_AccessDlg)
	m_strEdtFile = _T("");
	m_strStaResult = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPW_AccessDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPW_AccessDlg)
	DDX_Text(pDX, IDC_EDIT_FILE, m_strEdtFile);
	DDX_Text(pDX, IDC_STATIC_RESULT, m_strStaResult);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPW_AccessDlg, CDialog)
	//{{AFX_MSG_MAP(CPW_AccessDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_GET, OnButtonGet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPW_AccessDlg message handlers

BOOL CPW_AccessDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_strEdtFile = "F:\\Temp\\Db1.mdb";

	UpdateData (FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPW_AccessDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPW_AccessDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPW_AccessDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPW_AccessDlg::OnButtonOpen() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlgFile (TRUE,"*.mdb","*.mdb",OFN_HIDEREADONLY,"Access File (*.mdb)",this);

	if (dlgFile.DoModal () == IDOK)
		m_strEdtFile = dlgFile.GetPathName ();

	UpdateData (FALSE);
}

void CPW_AccessDlg::OnButtonGet() 
{
	// TODO: Add your control notification handler code here
	char			cWord[13];
	CFile			fp;
	CFileException	e;

	UpdateData (TRUE);
	int nRC = fp.Open (m_strEdtFile,CFile::modeRead,&e);
	if (nRC == 0)
	{
		AfxMessageBox ("Can not open the file!");
		return;
	}

	if (fp.GetLength () <= 80)
	{
		AfxMessageBox ("This is not Mdb file!");
		return;
	}

	fp.Seek (66,CFile::begin);
	fp.Read (cWord,13);
	fp.Close ();

	if ((BYTE)(cWord[0] ^ 0x86) == 0)
		m_strStaResult = "No Password";
	else
	{
		cWord[0] ^= 0x86;
		cWord[1] ^= 0xFB;
		cWord[2] ^= 0xEC;
		cWord[3] ^= 0x37;
		cWord[4] ^= 0x5D;
		cWord[5] ^= 0x44;
		cWord[6] ^= 0x9C;
		cWord[7] ^= 0xFA;
		cWord[8] ^= 0xC6;
		cWord[9] ^= 0x5E;
		cWord[10] ^= 0x28;
		cWord[11] ^= 0xE6;
		cWord[12] ^= 0x13;

		m_strStaResult = cWord;
	}
	UpdateData (FALSE);
}
